blob: bbb18e5f5cc4e6629078334b1438a5ba2edd52b0 [file] [log] [blame]
Scott Anderson1a5fc952012-03-07 17:15:06 -08001function hmm() {
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07002cat <<EOF
Jeff Gastonc6dfc4e2017-05-30 17:12:37 -07003
4Run "m help" for help with the build system itself.
5
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08006Invoke ". build/envsetup.sh" from your shell to add the following functions to your environment:
Steven Moreland62054a42018-12-06 10:11:40 -08007- lunch: lunch <product_name>-<build_variant>
8 Selects <product_name> as the product to build, and <build_variant> as the variant to
9 build, and stores those selections in the environment to be read by subsequent
10 invocations of 'm' etc.
Elliott Hughesf71c05a2020-03-06 16:46:59 -080011- tapas: tapas [<App1> <App2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
Martin Stjernholmf692c752021-04-12 00:01:10 +010012 Sets up the build environment for building unbundled apps (APKs).
13- banchan: banchan <module1> [<module2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
14 Sets up the build environment for building unbundled modules (APEXes).
Anton Hanssonece9c482019-02-04 18:15:39 +000015- croot: Changes directory to the top of the tree, or a subdirectory thereof.
Steven Moreland62054a42018-12-06 10:11:40 -080016- m: Makes from the top of the tree.
Dan Willemsen67074fe2019-10-30 12:35:34 -070017- mm: Builds and installs all of the modules in the current directory, and their
18 dependencies.
19- mmm: Builds and installs all of the modules in the supplied directories, and their
20 dependencies.
Steven Moreland62054a42018-12-06 10:11:40 -080021 To limit the modules being built use the syntax: mmm dir/:target1,target2.
Dan Willemsen67074fe2019-10-30 12:35:34 -070022- mma: Same as 'mm'
23- mmma: Same as 'mmm'
Steven Moreland62054a42018-12-06 10:11:40 -080024- provision: Flash device with all required partitions. Options will be passed on to fastboot.
25- cgrep: Greps on all local C/C++ files.
26- ggrep: Greps on all local Gradle files.
Orion Hodson831472d2019-10-25 11:35:15 +010027- gogrep: Greps on all local Go files.
Steven Moreland62054a42018-12-06 10:11:40 -080028- jgrep: Greps on all local Java files.
Taesu Leeea0cecd2020-10-28 11:05:18 +090029- ktgrep: Greps on all local Kotlin files.
Steven Moreland62054a42018-12-06 10:11:40 -080030- resgrep: Greps on all local res/*.xml files.
31- mangrep: Greps on all local AndroidManifest.xml files.
Jaewoong Jung892d0fe2019-05-04 10:06:28 -070032- mgrep: Greps on all local Makefiles and *.bp files.
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -060033- owngrep: Greps on all local OWNERS files.
Alistair Delva176e5342021-02-22 13:31:26 -080034- rsgrep: Greps on all local Rust files.
Steven Moreland62054a42018-12-06 10:11:40 -080035- sepgrep: Greps on all local sepolicy files.
36- sgrep: Greps on all local source files.
37- godir: Go to the directory containing a file.
38- allmod: List all modules.
39- gomod: Go to the directory containing a module.
Rett Berg78d1c932019-01-24 14:34:23 -080040- pathmod: Get the directory containing a module.
Cole Faust24c36db2021-01-23 02:39:37 +000041- outmod: Gets the location of a module's installed outputs with a certain extension.
Joe Onorato2c1aa472021-02-25 16:42:39 -080042- dirmods: Gets the modules defined in a given directory.
Cole Faust24c36db2021-01-23 02:39:37 +000043- installmod: Adb installs a module's built APK.
44- refreshmod: Refresh list of modules for allmod/gomod/pathmod/outmod/installmod.
Steven Moreland74114f12020-09-10 01:23:32 +000045- syswrite: Remount partitions (e.g. system.img) as writable, rebooting if necessary.
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070046
Roland Levillain39341922015-10-20 12:48:19 +010047Environment options:
Steven Moreland115d1f52019-09-26 16:30:28 -070048- SANITIZE_HOST: Set to 'address' to use ASAN for all host modules.
Sasha Smundak9f27cc02019-01-31 13:25:31 -080049- ANDROID_QUIET_BUILD: set to 'true' to display only the essential messages.
Dan Albert4ae5d4b2014-10-31 16:23:08 -070050
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070051Look at the source to view more functions. The complete list is:
52EOF
Christopher Ferris55257d22017-03-23 11:08:58 -070053 local T=$(gettop)
54 local A=""
55 local i
Jacky Cao89483b82015-05-15 22:12:53 +080056 for i in `cat $T/build/envsetup.sh | sed -n "/^[[:blank:]]*function /s/function \([a-z_]*\).*/\1/p" | sort | uniq`; do
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070057 A="$A $i"
58 done
59 echo $A
60}
61
Ying Wang08800fd2016-03-03 20:57:21 -080062# Get all the build variables needed by this script in a single call to the build system.
Matt Alexanderd9c56562020-05-21 10:49:17 +000063function build_build_var_cache()
64{
Christopher Ferris55257d22017-03-23 11:08:58 -070065 local T=$(gettop)
Ying Wang08800fd2016-03-03 20:57:21 -080066 # Grep out the variable names from the script.
Jim Tanga881a252018-06-19 16:34:41 +080067 cached_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
68 cached_abs_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_abs_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
Ying Wang08800fd2016-03-03 20:57:21 -080069 # Call the build system to dump the "<val>=<value>" pairs as a shell script.
Steven Moreland05402962018-01-05 12:13:11 -080070 build_dicts_script=`\builtin cd $T; build/soong/soong_ui.bash --dumpvars-mode \
Jim Tanga881a252018-06-19 16:34:41 +080071 --vars="${cached_vars[*]}" \
72 --abs-vars="${cached_abs_vars[*]}" \
Dan Willemsenaf88c412017-07-14 11:29:44 -070073 --var-prefix=var_cache_ \
74 --abs-var-prefix=abs_var_cache_`
Ying Wang08800fd2016-03-03 20:57:21 -080075 local ret=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +000076 if [ $ret -ne 0 ]
77 then
Ying Wang08800fd2016-03-03 20:57:21 -080078 unset build_dicts_script
79 return $ret
80 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -070081 # Execute the script to store the "<val>=<value>" pairs as shell variables.
Ying Wang08800fd2016-03-03 20:57:21 -080082 eval "$build_dicts_script"
Ying Wang08800fd2016-03-03 20:57:21 -080083 ret=$?
Ying Wangf0cb3972016-03-04 13:56:23 -080084 unset build_dicts_script
Matt Alexanderd9c56562020-05-21 10:49:17 +000085 if [ $ret -ne 0 ]
86 then
Ying Wang08800fd2016-03-03 20:57:21 -080087 return $ret
88 fi
89 BUILD_VAR_CACHE_READY="true"
90}
91
Ying Wangf0cb3972016-03-04 13:56:23 -080092# Delete the build var cache, so that we can still call into the build system
Ying Wang08800fd2016-03-03 20:57:21 -080093# to get build variables not listed in this script.
Matt Alexanderd9c56562020-05-21 10:49:17 +000094function destroy_build_var_cache()
95{
Ying Wang08800fd2016-03-03 20:57:21 -080096 unset BUILD_VAR_CACHE_READY
Christopher Ferris55257d22017-03-23 11:08:58 -070097 local v
Ying Wang08800fd2016-03-03 20:57:21 -080098 for v in $cached_vars; do
99 unset var_cache_$v
100 done
101 unset cached_vars
102 for v in $cached_abs_vars; do
103 unset abs_var_cache_$v
104 done
105 unset cached_abs_vars
106}
107
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700108# Get the value of a build variable as an absolute path.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000109function get_abs_build_var()
110{
111 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
112 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800113 eval "echo \"\${abs_var_cache_$1}\""
Timi0469c3f2021-04-15 16:41:18 +0200114 return
Ying Wang08800fd2016-03-03 20:57:21 -0800115 fi
116
Christopher Ferris55257d22017-03-23 11:08:58 -0700117 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700118 if [ ! "$T" ]; then
119 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
120 return
121 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700122 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode --abs $1)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700123}
124
125# Get the exact value of a build variable.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000126function get_build_var()
127{
128 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
129 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800130 eval "echo \"\${var_cache_$1}\""
Roland Levillain23c46cf2020-03-31 16:11:05 +0100131 return 0
Ying Wang08800fd2016-03-03 20:57:21 -0800132 fi
133
Christopher Ferris55257d22017-03-23 11:08:58 -0700134 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700135 if [ ! "$T" ]; then
136 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
Roland Levillain23c46cf2020-03-31 16:11:05 +0100137 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700138 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700139 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode $1)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800140}
141
142# check to see if the supplied product is one we can build
Matt Alexanderd9c56562020-05-21 10:49:17 +0000143function check_product()
144{
Christopher Ferris55257d22017-03-23 11:08:58 -0700145 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800146 if [ ! "$T" ]; then
147 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
148 return
149 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700150 TARGET_PRODUCT=$1 \
151 TARGET_BUILD_VARIANT= \
152 TARGET_BUILD_TYPE= \
Joe Onoratoda12daf2010-06-09 18:18:31 -0700153 TARGET_BUILD_APPS= \
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800154 get_build_var TARGET_DEVICE > /dev/null
155 # hide successful answers, but allow the errors to show
156}
157
158VARIANT_CHOICES=(user userdebug eng)
159
160# check to see if the supplied variant is valid
Matt Alexanderd9c56562020-05-21 10:49:17 +0000161function check_variant()
162{
Christopher Ferris55257d22017-03-23 11:08:58 -0700163 local v
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800164 for v in ${VARIANT_CHOICES[@]}
165 do
Matt Alexanderd9c56562020-05-21 10:49:17 +0000166 if [ "$v" = "$1" ]
167 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800168 return 0
169 fi
170 done
171 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700172}
173
Matt Alexanderd9c56562020-05-21 10:49:17 +0000174function setpaths()
175{
Christopher Ferris55257d22017-03-23 11:08:58 -0700176 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700177 if [ ! "$T" ]; then
178 echo "Couldn't locate the top of the tree. Try setting TOP."
179 return
180 fi
181
182 ##################################################################
183 # #
184 # Read me before you modify this code #
185 # #
186 # This function sets ANDROID_BUILD_PATHS to what it is adding #
187 # to PATH, and the next time it is run, it removes that from #
188 # PATH. This is required so lunch can be run more than once #
189 # and still have working paths. #
190 # #
191 ##################################################################
192
Raphael Mollc639c782011-06-20 17:25:01 -0700193 # Note: on windows/cygwin, ANDROID_BUILD_PATHS will contain spaces
194 # due to "C:\Program Files" being in the path.
195
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700196 # out with the old
Matt Alexanderd9c56562020-05-21 10:49:17 +0000197 if [ -n "$ANDROID_BUILD_PATHS" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700198 export PATH=${PATH/$ANDROID_BUILD_PATHS/}
199 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000200 if [ -n "$ANDROID_PRE_BUILD_PATHS" ] ; then
Doug Zongker29034982011-04-22 08:16:56 -0700201 export PATH=${PATH/$ANDROID_PRE_BUILD_PATHS/}
Ying Wangaa1c9b52012-11-26 20:51:59 -0800202 # strip leading ':', if any
203 export PATH=${PATH/:%/}
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500204 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700205
206 # and in with the new
Christopher Ferris55257d22017-03-23 11:08:58 -0700207 local prebuiltdir=$(getprebuilt)
208 local gccprebuiltdir=$(get_abs_build_var ANDROID_GCC_PREBUILTS)
Raphael732936d2011-06-22 14:35:32 -0700209
Ben Cheng8bc4c432012-11-16 13:29:13 -0800210 # defined in core/config.mk
Christopher Ferris55257d22017-03-23 11:08:58 -0700211 local targetgccversion=$(get_build_var TARGET_GCC_VERSION)
212 local targetgccversion2=$(get_build_var 2ND_TARGET_GCC_VERSION)
Ben Cheng15266702012-12-10 16:04:39 -0800213 export TARGET_GCC_VERSION=$targetgccversion
Ben Cheng8bc4c432012-11-16 13:29:13 -0800214
Raphael Mollc639c782011-06-20 17:25:01 -0700215 # The gcc toolchain does not exists for windows/cygwin. In this case, do not reference it.
Ben Chengfba67bf2014-02-25 10:27:07 -0800216 export ANDROID_TOOLCHAIN=
217 export ANDROID_TOOLCHAIN_2ND_ARCH=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200218 local ARCH=$(get_build_var TARGET_ARCH)
Christopher Ferris55257d22017-03-23 11:08:58 -0700219 local toolchaindir toolchaindir2=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200220 case $ARCH in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000221 x86) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Mark D Horn7d0ede72012-03-14 14:20:30 -0700222 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000223 x86_64) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Pavel Chupinfd82a492012-11-26 09:50:07 +0400224 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000225 arm) toolchaindir=arm/arm-linux-androideabi-$targetgccversion/bin
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200226 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000227 arm64) toolchaindir=aarch64/aarch64-linux-android-$targetgccversion/bin;
228 toolchaindir2=arm/arm-linux-androideabi-$targetgccversion2/bin
Ben Chengdb4fc202013-10-04 16:02:59 -0700229 ;;
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200230 *)
231 echo "Can't find toolchain for unknown architecture: $ARCH"
232 toolchaindir=xxxxxxxxx
Mark D Horn7d0ede72012-03-14 14:20:30 -0700233 ;;
234 esac
Jing Yuf5172c72012-03-29 20:45:50 -0700235 if [ -d "$gccprebuiltdir/$toolchaindir" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800236 export ANDROID_TOOLCHAIN=$gccprebuiltdir/$toolchaindir
Raphael Mollc639c782011-06-20 17:25:01 -0700237 fi
Raphael732936d2011-06-22 14:35:32 -0700238
Christopher Ferris55257d22017-03-23 11:08:58 -0700239 if [ "$toolchaindir2" -a -d "$gccprebuiltdir/$toolchaindir2" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800240 export ANDROID_TOOLCHAIN_2ND_ARCH=$gccprebuiltdir/$toolchaindir2
241 fi
242
Jeff Vander Stoep5f50f052015-06-12 09:56:39 -0700243 export ANDROID_DEV_SCRIPTS=$T/development/scripts:$T/prebuilts/devtools/tools:$T/external/selinux/prebuilts/bin
Yueyao Zhuefc786a2017-04-07 14:11:54 -0700244
245 # add kernel specific binaries
246 case $(uname -s) in
247 Linux)
248 export ANDROID_DEV_SCRIPTS=$ANDROID_DEV_SCRIPTS:$T/prebuilts/misc/linux-x86/dtc:$T/prebuilts/misc/linux-x86/libufdt
249 ;;
250 *)
251 ;;
252 esac
253
Torne (Richard Coles)0091bae2017-10-03 16:31:18 -0400254 ANDROID_BUILD_PATHS=$(get_build_var ANDROID_BUILD_PATHS):$ANDROID_TOOLCHAIN
255 if [ -n "$ANDROID_TOOLCHAIN_2ND_ARCH" ]; then
256 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_TOOLCHAIN_2ND_ARCH
257 fi
Yi Kongdfd00b12019-05-21 16:00:04 -0700258 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_DEV_SCRIPTS
259
260 # Append llvm binutils prebuilts path to ANDROID_BUILD_PATHS.
261 local ANDROID_LLVM_BINUTILS=$(get_abs_build_var ANDROID_CLANG_PREBUILTS)/llvm-binutils-stable
262 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_LLVM_BINUTILS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200263
Stephen Hinesaa8d72c2020-02-04 09:15:18 -0800264 # Set up ASAN_SYMBOLIZER_PATH for SANITIZE_HOST=address builds.
265 export ASAN_SYMBOLIZER_PATH=$ANDROID_LLVM_BINUTILS/llvm-symbolizer
266
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200267 # If prebuilts/android-emulator/<system>/ exists, prepend it to our PATH
268 # to ensure that the corresponding 'emulator' binaries are used.
269 case $(uname -s) in
270 Darwin)
271 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/darwin-x86_64
272 ;;
273 Linux)
274 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/linux-x86_64
275 ;;
276 *)
277 ANDROID_EMULATOR_PREBUILTS=
278 ;;
279 esac
280 if [ -n "$ANDROID_EMULATOR_PREBUILTS" -a -d "$ANDROID_EMULATOR_PREBUILTS" ]; then
Yi Kongdfd00b12019-05-21 16:00:04 -0700281 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_EMULATOR_PREBUILTS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200282 export ANDROID_EMULATOR_PREBUILTS
283 fi
284
Jim Tangb3fda302018-12-22 10:24:55 +0800285 # Append asuite prebuilts path to ANDROID_BUILD_PATHS.
286 local os_arch=$(get_build_var HOST_PREBUILT_TAG)
Ryan Prichard8426a192019-07-15 18:05:29 -0700287 local ACLOUD_PATH="$T/prebuilts/asuite/acloud/$os_arch"
288 local AIDEGEN_PATH="$T/prebuilts/asuite/aidegen/$os_arch"
289 local ATEST_PATH="$T/prebuilts/asuite/atest/$os_arch"
290 export ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ACLOUD_PATH:$AIDEGEN_PATH:$ATEST_PATH:
Jim Tangb3fda302018-12-22 10:24:55 +0800291
Ryan Prichard8426a192019-07-15 18:05:29 -0700292 export PATH=$ANDROID_BUILD_PATHS$PATH
Jim Tang22f4c322018-12-17 15:21:53 +0800293
294 # out with the duplicate old
295 if [ -n $ANDROID_PYTHONPATH ]; then
296 export PYTHONPATH=${PYTHONPATH//$ANDROID_PYTHONPATH/}
297 fi
298 # and in with the new
299 export ANDROID_PYTHONPATH=$T/development/python-packages:
Jim Tangc4dba1d2019-07-25 16:54:27 +0800300 if [ -n $VENDOR_PYTHONPATH ]; then
301 ANDROID_PYTHONPATH=$ANDROID_PYTHONPATH$VENDOR_PYTHONPATH
302 fi
Jim Tang22f4c322018-12-17 15:21:53 +0800303 export PYTHONPATH=$ANDROID_PYTHONPATH$PYTHONPATH
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800304
Colin Crosse97e6932017-06-30 16:01:45 -0700305 export ANDROID_JAVA_HOME=$(get_abs_build_var ANDROID_JAVA_HOME)
306 export JAVA_HOME=$ANDROID_JAVA_HOME
307 export ANDROID_JAVA_TOOLCHAIN=$(get_abs_build_var ANDROID_JAVA_TOOLCHAIN)
308 export ANDROID_PRE_BUILD_PATHS=$ANDROID_JAVA_TOOLCHAIN:
309 export PATH=$ANDROID_PRE_BUILD_PATHS$PATH
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500310
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800311 unset ANDROID_PRODUCT_OUT
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700312 export ANDROID_PRODUCT_OUT=$(get_abs_build_var PRODUCT_OUT)
313 export OUT=$ANDROID_PRODUCT_OUT
314
Jeff Brown8fd5cce2011-03-24 17:03:06 -0700315 unset ANDROID_HOST_OUT
316 export ANDROID_HOST_OUT=$(get_abs_build_var HOST_OUT)
317
Jiyong Parkc02b1c42020-11-03 11:06:39 +0900318 unset ANDROID_SOONG_HOST_OUT
319 export ANDROID_SOONG_HOST_OUT=$(get_abs_build_var SOONG_HOST_OUT)
320
Simran Basidd050ed2017-02-13 13:46:48 -0800321 unset ANDROID_HOST_OUT_TESTCASES
322 export ANDROID_HOST_OUT_TESTCASES=$(get_abs_build_var HOST_OUT_TESTCASES)
323
324 unset ANDROID_TARGET_OUT_TESTCASES
325 export ANDROID_TARGET_OUT_TESTCASES=$(get_abs_build_var TARGET_OUT_TESTCASES)
326
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800327 # needed for building linux on MacOS
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700328 # TODO: fix the path
329 #export HOST_EXTRACFLAGS="-I "$T/system/kernel_headers/host_include
330}
331
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000332function bazel()
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000333{
Jingwen Chen17d56992021-06-10 08:17:54 +0000334 if which bazel &>/dev/null; then
335 >&2 echo "NOTE: bazel() function sourced from Android's envsetup.sh is being used instead of $(which bazel)"
336 >&2 echo
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000337 fi
338
Jingwen Chen17d56992021-06-10 08:17:54 +0000339 local T="$(gettop)"
340 if [ ! "$T" ]; then
341 >&2 echo "Couldn't locate the top of the Android tree. Try setting TOP. This bazel() function cannot be used outside of the AOSP directory."
342 return
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000343 fi
344
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000345 "$T/tools/bazel" "$@"
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000346}
347
Matt Alexanderd9c56562020-05-21 10:49:17 +0000348function printconfig()
349{
Christopher Ferris55257d22017-03-23 11:08:58 -0700350 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800351 if [ ! "$T" ]; then
352 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
353 return
354 fi
355 get_build_var report_config
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700356}
357
Matt Alexanderd9c56562020-05-21 10:49:17 +0000358function set_stuff_for_environment()
359{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800360 setpaths
361 set_sequence_number
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700362
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800363 export ANDROID_BUILD_TOP=$(gettop)
Ben Chengaac3f812013-08-13 14:38:15 -0700364 # With this environment variable new GCC can apply colors to warnings/errors
365 export GCC_COLORS='error=01;31:warning=01;35:note=01;36:caret=01;32:locus=01:quote=01'
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700366}
367
Matt Alexanderd9c56562020-05-21 10:49:17 +0000368function set_sequence_number()
369{
Colin Cross88737132017-03-21 17:41:03 -0700370 export BUILD_ENV_SEQUENCE_NUMBER=13
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700371}
372
Makoto Onukida971062018-06-18 10:15:19 -0700373# Takes a command name, and check if it's in ENVSETUP_NO_COMPLETION or not.
374function should_add_completion() {
Jim Tanga881a252018-06-19 16:34:41 +0800375 local cmd="$(basename $1| sed 's/_completion//' |sed 's/\.\(.*\)*sh$//')"
Makoto Onukida971062018-06-18 10:15:19 -0700376 case :"$ENVSETUP_NO_COMPLETION": in
Jim Tanga881a252018-06-19 16:34:41 +0800377 *:"$cmd":*)
378 return 1
379 ;;
Makoto Onukida971062018-06-18 10:15:19 -0700380 esac
381 return 0
382}
383
Matt Alexanderd9c56562020-05-21 10:49:17 +0000384function addcompletions()
385{
Ben Taitelbaum8c2c9cf2020-09-22 16:45:05 -0700386 local f=
Kenny Root52aa81c2011-07-15 11:07:06 -0700387
Jim Tanga881a252018-06-19 16:34:41 +0800388 # Keep us from trying to run in something that's neither bash nor zsh.
389 if [ -z "$BASH_VERSION" -a -z "$ZSH_VERSION" ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700390 return
391 fi
392
393 # Keep us from trying to run in bash that's too old.
Jim Tanga881a252018-06-19 16:34:41 +0800394 if [ -n "$BASH_VERSION" -a ${BASH_VERSINFO[0]} -lt 3 ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700395 return
396 fi
397
Jim Tanga881a252018-06-19 16:34:41 +0800398 local completion_files=(
399 system/core/adb/adb.bash
400 system/core/fastboot/fastboot.bash
Jim Tangb3fda302018-12-22 10:24:55 +0800401 tools/asuite/asuite.sh
Jim Tanga881a252018-06-19 16:34:41 +0800402 )
Makoto Onukida971062018-06-18 10:15:19 -0700403 # Completion can be disabled selectively to allow users to use non-standard completion.
404 # e.g.
405 # ENVSETUP_NO_COMPLETION=adb # -> disable adb completion
406 # ENVSETUP_NO_COMPLETION=adb:bit # -> disable adb and bit completion
Jim Tanga881a252018-06-19 16:34:41 +0800407 for f in ${completion_files[*]}; do
408 if [ -f "$f" ] && should_add_completion "$f"; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700409 . $f
Elliott Hughesce18dd42018-04-03 13:49:48 -0700410 fi
411 done
Joe Onorato002a6c72016-10-20 16:39:49 -0700412
Matt Alexanderd9c56562020-05-21 10:49:17 +0000413 if should_add_completion bit ; then
Makoto Onukida971062018-06-18 10:15:19 -0700414 complete -C "bit --tab" bit
415 fi
Anton Hanssonece9c482019-02-04 18:15:39 +0000416 if [ -z "$ZSH_VERSION" ]; then
417 # Doesn't work in zsh.
418 complete -o nospace -F _croot croot
419 fi
Jim Tanga881a252018-06-19 16:34:41 +0800420 complete -F _lunch lunch
Steven Moreland62054a42018-12-06 10:11:40 -0800421
Cole Faust24c36db2021-01-23 02:39:37 +0000422 complete -F _complete_android_module_names pathmod
dimitry73b84812018-12-11 18:06:00 +0100423 complete -F _complete_android_module_names gomod
Cole Faust24c36db2021-01-23 02:39:37 +0000424 complete -F _complete_android_module_names outmod
425 complete -F _complete_android_module_names installmod
dimitry73b84812018-12-11 18:06:00 +0100426 complete -F _complete_android_module_names m
Kenny Root52aa81c2011-07-15 11:07:06 -0700427}
428
Matt Alexanderd9c56562020-05-21 10:49:17 +0000429function choosetype()
430{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700431 echo "Build type choices are:"
432 echo " 1. release"
433 echo " 2. debug"
434 echo
435
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800436 local DEFAULT_NUM DEFAULT_VALUE
Jeff Browne33ba4c2011-07-11 22:11:46 -0700437 DEFAULT_NUM=1
438 DEFAULT_VALUE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700439
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800440 export TARGET_BUILD_TYPE=
441 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700442 while [ -z $TARGET_BUILD_TYPE ]
443 do
444 echo -n "Which would you like? ["$DEFAULT_NUM"] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000445 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800446 read ANSWER
447 else
448 echo $1
449 ANSWER=$1
450 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700451 case $ANSWER in
452 "")
453 export TARGET_BUILD_TYPE=$DEFAULT_VALUE
454 ;;
455 1)
456 export TARGET_BUILD_TYPE=release
457 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800458 release)
459 export TARGET_BUILD_TYPE=release
460 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700461 2)
462 export TARGET_BUILD_TYPE=debug
463 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800464 debug)
465 export TARGET_BUILD_TYPE=debug
466 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700467 *)
468 echo
469 echo "I didn't understand your response. Please try again."
470 echo
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700471 ;;
472 esac
Matt Alexanderd9c56562020-05-21 10:49:17 +0000473 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800474 break
475 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700476 done
477
Ying Wang08800fd2016-03-03 20:57:21 -0800478 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700479 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800480 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700481}
482
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800483#
484# This function isn't really right: It chooses a TARGET_PRODUCT
485# based on the list of boards. Usually, that gets you something
486# that kinda works with a generic product, but really, you should
487# pick a product by name.
488#
Matt Alexanderd9c56562020-05-21 10:49:17 +0000489function chooseproduct()
490{
Christopher Ferris55257d22017-03-23 11:08:58 -0700491 local default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000492 if [ "x$TARGET_PRODUCT" != x ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700493 default_value=$TARGET_PRODUCT
494 else
Ying Wang0a76df52015-06-08 11:57:26 -0700495 default_value=aosp_arm
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700496 fi
497
Ying Wang08800fd2016-03-03 20:57:21 -0800498 export TARGET_BUILD_APPS=
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800499 export TARGET_PRODUCT=
500 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700501 while [ -z "$TARGET_PRODUCT" ]
502 do
Joe Onorato8849aed2009-04-29 15:56:47 -0700503 echo -n "Which product would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000504 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800505 read ANSWER
506 else
507 echo $1
508 ANSWER=$1
509 fi
510
Matt Alexanderd9c56562020-05-21 10:49:17 +0000511 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700512 export TARGET_PRODUCT=$default_value
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800513 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000514 if check_product $ANSWER
515 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800516 export TARGET_PRODUCT=$ANSWER
517 else
518 echo "** Not a valid product: $ANSWER"
519 fi
520 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000521 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800522 break
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700523 fi
524 done
525
Ying Wang08800fd2016-03-03 20:57:21 -0800526 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700527 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800528 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700529}
530
Matt Alexanderd9c56562020-05-21 10:49:17 +0000531function choosevariant()
532{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800533 echo "Variant choices are:"
534 local index=1
535 local v
536 for v in ${VARIANT_CHOICES[@]}
537 do
538 # The product name is the name of the directory containing
539 # the makefile we found, above.
540 echo " $index. $v"
541 index=$(($index+1))
542 done
543
544 local default_value=eng
545 local ANSWER
546
547 export TARGET_BUILD_VARIANT=
548 while [ -z "$TARGET_BUILD_VARIANT" ]
549 do
550 echo -n "Which would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000551 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800552 read ANSWER
553 else
554 echo $1
555 ANSWER=$1
556 fi
557
Matt Alexanderd9c56562020-05-21 10:49:17 +0000558 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800559 export TARGET_BUILD_VARIANT=$default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000560 elif (echo -n $ANSWER | grep -q -e "^[0-9][0-9]*$") ; then
561 if [ "$ANSWER" -le "${#VARIANT_CHOICES[@]}" ] ; then
Guillaume Chelfice000fd2019-10-03 12:02:46 +0200562 export TARGET_BUILD_VARIANT=${VARIANT_CHOICES[@]:$(($ANSWER-1)):1}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800563 fi
564 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000565 if check_variant $ANSWER
566 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800567 export TARGET_BUILD_VARIANT=$ANSWER
568 else
569 echo "** Not a valid variant: $ANSWER"
570 fi
571 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000572 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800573 break
574 fi
575 done
576}
577
Matt Alexanderd9c56562020-05-21 10:49:17 +0000578function choosecombo()
579{
Jeff Browne33ba4c2011-07-11 22:11:46 -0700580 choosetype $1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700581
582 echo
583 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700584 chooseproduct $2
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700585
586 echo
587 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700588 choosevariant $3
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800589
590 echo
Ying Wang08800fd2016-03-03 20:57:21 -0800591 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700592 set_stuff_for_environment
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800593 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800594 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700595}
596
Matt Alexanderd9c56562020-05-21 10:49:17 +0000597function add_lunch_combo()
598{
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800599 if [ -n "$ZSH_VERSION" ]; then
600 echo -n "${funcfiletrace[1]}: "
601 else
602 echo -n "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: "
603 fi
604 echo "add_lunch_combo is obsolete. Use COMMON_LUNCH_CHOICES in your AndroidProducts.mk instead."
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800605}
606
Matt Alexanderd9c56562020-05-21 10:49:17 +0000607function print_lunch_menu()
608{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700609 local uname=$(uname)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100610 local choices
Colin Crossfa50d402021-04-22 13:05:41 -0700611 choices=$(TARGET_BUILD_APPS= TARGET_PRODUCT= TARGET_BUILD_VARIANT= get_build_var COMMON_LUNCH_CHOICES 2>/dev/null)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100612 local ret=$?
613
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700614 echo
615 echo "You're building on" $uname
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700616 echo
Roland Levillain23c46cf2020-03-31 16:11:05 +0100617
Matt Alexanderd9c56562020-05-21 10:49:17 +0000618 if [ $ret -ne 0 ]
619 then
Roland Levillain23c46cf2020-03-31 16:11:05 +0100620 echo "Warning: Cannot display lunch menu."
621 echo
622 echo "Note: You can invoke lunch with an explicit target:"
623 echo
624 echo " usage: lunch [target]" >&2
625 echo
626 return
627 fi
628
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700629 echo "Lunch menu... pick a combo:"
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800630
631 local i=1
632 local choice
Dan Willemsen91763e92019-10-03 15:13:12 -0700633 for choice in $(echo $choices)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800634 do
635 echo " $i. $choice"
636 i=$(($i+1))
637 done
638
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700639 echo
640}
641
Matt Alexanderd9c56562020-05-21 10:49:17 +0000642function lunch()
643{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800644 local answer
645
Steven Moreland92793dc2020-02-25 18:30:18 -0800646 if [[ $# -gt 1 ]]; then
647 echo "usage: lunch [target]" >&2
648 return 1
649 fi
650
651 if [ "$1" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800652 answer=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700653 else
654 print_lunch_menu
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700655 echo -n "Which would you like? [aosp_arm-eng] "
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800656 read answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700657 fi
658
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800659 local selection=
660
Matt Alexanderd9c56562020-05-21 10:49:17 +0000661 if [ -z "$answer" ]
662 then
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700663 selection=aosp_arm-eng
Matt Alexanderd9c56562020-05-21 10:49:17 +0000664 elif (echo -n $answer | grep -q -e "^[0-9][0-9]*$")
665 then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800666 local choices=($(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES))
Matt Alexanderd9c56562020-05-21 10:49:17 +0000667 if [ $answer -le ${#choices[@]} ]
668 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800669 # array in zsh starts from 1 instead of 0.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000670 if [ -n "$ZSH_VERSION" ]
671 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800672 selection=${choices[$(($answer))]}
673 else
674 selection=${choices[$(($answer-1))]}
675 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800676 fi
Colin Cross88737132017-03-21 17:41:03 -0700677 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800678 selection=$answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700679 fi
680
Joe Onoratoda12daf2010-06-09 18:18:31 -0700681 export TARGET_BUILD_APPS=
682
Colin Cross88737132017-03-21 17:41:03 -0700683 local product variant_and_version variant version
Colin Cross88737132017-03-21 17:41:03 -0700684 product=${selection%%-*} # Trim everything after first dash
685 variant_and_version=${selection#*-} # Trim everything up to first dash
686 if [ "$variant_and_version" != "$selection" ]; then
687 variant=${variant_and_version%%-*}
688 if [ "$variant" != "$variant_and_version" ]; then
689 version=${variant_and_version#*-}
690 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700691 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800692
Matt Alexanderd9c56562020-05-21 10:49:17 +0000693 if [ -z "$product" ]
694 then
Ying Wang08800fd2016-03-03 20:57:21 -0800695 echo
Colin Cross88737132017-03-21 17:41:03 -0700696 echo "Invalid lunch combo: $selection"
Jeff Browne33ba4c2011-07-11 22:11:46 -0700697 return 1
698 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800699
Colin Cross88737132017-03-21 17:41:03 -0700700 TARGET_PRODUCT=$product \
701 TARGET_BUILD_VARIANT=$variant \
702 TARGET_PLATFORM_VERSION=$version \
703 build_build_var_cache
Matt Alexanderd9c56562020-05-21 10:49:17 +0000704 if [ $? -ne 0 ]
705 then
Anton Hansson32fa7ee2021-06-14 17:09:58 +0100706 if [[ "$product" =~ .*_(eng|user|userdebug) ]]
707 then
708 echo "Did you mean -${product/*_/}? (dash instead of underscore)"
709 fi
Colin Cross88737132017-03-21 17:41:03 -0700710 return 1
711 fi
Colin Cross88737132017-03-21 17:41:03 -0700712 export TARGET_PRODUCT=$(get_build_var TARGET_PRODUCT)
713 export TARGET_BUILD_VARIANT=$(get_build_var TARGET_BUILD_VARIANT)
Colin Crossb105e362017-05-01 14:21:28 -0700714 if [ -n "$version" ]; then
715 export TARGET_PLATFORM_VERSION=$(get_build_var TARGET_PLATFORM_VERSION)
716 else
717 unset TARGET_PLATFORM_VERSION
718 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700719 export TARGET_BUILD_TYPE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700720
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700721 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || echo
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800722
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700723 set_stuff_for_environment
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700724 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800725 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700726}
727
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700728unset COMMON_LUNCH_CHOICES_CACHE
Jeff Davidson513d7a42010-08-02 10:00:44 -0700729# Tab completion for lunch.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000730function _lunch()
731{
Jeff Davidson513d7a42010-08-02 10:00:44 -0700732 local cur prev opts
733 COMPREPLY=()
734 cur="${COMP_WORDS[COMP_CWORD]}"
735 prev="${COMP_WORDS[COMP_CWORD-1]}"
736
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700737 if [ -z "$COMMON_LUNCH_CHOICES_CACHE" ]; then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800738 COMMON_LUNCH_CHOICES_CACHE=$(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES)
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700739 fi
740
741 COMPREPLY=( $(compgen -W "${COMMON_LUNCH_CHOICES_CACHE}" -- ${cur}) )
Jeff Davidson513d7a42010-08-02 10:00:44 -0700742 return 0
743}
Jeff Davidson513d7a42010-08-02 10:00:44 -0700744
Joe Onoratoda12daf2010-06-09 18:18:31 -0700745# Configures the build to build unbundled apps.
Doug Zongker0d8179e2014-04-16 11:34:34 -0700746# Run tapas with one or more app names (from LOCAL_PACKAGE_NAME)
Matt Alexanderd9c56562020-05-21 10:49:17 +0000747function tapas()
748{
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700749 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800750 local arch="$(echo $* | xargs -n 1 echo | \grep -E '^(arm|x86|arm64|x86_64)$' | xargs)"
Doug Zongker0d8179e2014-04-16 11:34:34 -0700751 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700752 local density="$(echo $* | xargs -n 1 echo | \grep -E '^(ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800753 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|arm|x86|arm64|x86_64|ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Joe Onoratoda12daf2010-06-09 18:18:31 -0700754
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700755 if [ "$showHelp" != "" ]; then
756 $(gettop)/build/make/tapasHelp.sh
757 return
758 fi
759
Ying Wang67f02922012-08-22 10:25:20 -0700760 if [ $(echo $arch | wc -w) -gt 1 ]; then
761 echo "tapas: Error: Multiple build archs supplied: $arch"
762 return
763 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700764 if [ $(echo $variant | wc -w) -gt 1 ]; then
765 echo "tapas: Error: Multiple build variants supplied: $variant"
766 return
767 fi
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700768 if [ $(echo $density | wc -w) -gt 1 ]; then
769 echo "tapas: Error: Multiple densities supplied: $density"
770 return
771 fi
Ying Wang67f02922012-08-22 10:25:20 -0700772
Ying Wang0a76df52015-06-08 11:57:26 -0700773 local product=aosp_arm
Ying Wang67f02922012-08-22 10:25:20 -0700774 case $arch in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000775 x86) product=aosp_x86;;
776 arm64) product=aosp_arm64;;
777 x86_64) product=aosp_x86_64;;
Ying Wang67f02922012-08-22 10:25:20 -0700778 esac
Joe Onoratoda12daf2010-06-09 18:18:31 -0700779 if [ -z "$variant" ]; then
780 variant=eng
781 fi
Ying Wangc048c9b2010-06-24 15:08:33 -0700782 if [ -z "$apps" ]; then
783 apps=all
784 fi
Justin Morey29d225c2014-11-04 13:35:51 -0600785 if [ -z "$density" ]; then
786 density=alldpi
787 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700788
Ying Wang67f02922012-08-22 10:25:20 -0700789 export TARGET_PRODUCT=$product
Joe Onoratoda12daf2010-06-09 18:18:31 -0700790 export TARGET_BUILD_VARIANT=$variant
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700791 export TARGET_BUILD_DENSITY=$density
Joe Onoratoda12daf2010-06-09 18:18:31 -0700792 export TARGET_BUILD_TYPE=release
793 export TARGET_BUILD_APPS=$apps
794
Ying Wang08800fd2016-03-03 20:57:21 -0800795 build_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700796 set_stuff_for_environment
797 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800798 destroy_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700799}
800
Martin Stjernholmf692c752021-04-12 00:01:10 +0100801# Configures the build to build unbundled Android modules (APEXes).
802# Run banchan with one or more module names (from apex{} modules).
803function banchan()
804{
805 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100806 local product="$(echo $* | xargs -n 1 echo | \grep -E '^(.*_)?(arm|x86|arm64|x86_64)$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100807 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100808 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|(.*_)?(arm|x86|arm64|x86_64))$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100809
810 if [ "$showHelp" != "" ]; then
811 $(gettop)/build/make/banchanHelp.sh
812 return
813 fi
814
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100815 if [ -z "$product" ]; then
816 product=arm
817 elif [ $(echo $product | wc -w) -gt 1 ]; then
818 echo "banchan: Error: Multiple build archs or products supplied: $products"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100819 return
820 fi
821 if [ $(echo $variant | wc -w) -gt 1 ]; then
822 echo "banchan: Error: Multiple build variants supplied: $variant"
823 return
824 fi
825 if [ -z "$apps" ]; then
826 echo "banchan: Error: No modules supplied"
827 return
828 fi
829
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100830 case $product in
831 arm) product=module_arm;;
Martin Stjernholmf692c752021-04-12 00:01:10 +0100832 x86) product=module_x86;;
833 arm64) product=module_arm64;;
834 x86_64) product=module_x86_64;;
835 esac
836 if [ -z "$variant" ]; then
837 variant=eng
838 fi
839
840 export TARGET_PRODUCT=$product
841 export TARGET_BUILD_VARIANT=$variant
842 export TARGET_BUILD_DENSITY=alldpi
843 export TARGET_BUILD_TYPE=release
844
845 # This setup currently uses TARGET_BUILD_APPS just like tapas, but the use
846 # case is different and it may diverge in the future.
847 export TARGET_BUILD_APPS=$apps
848
849 build_build_var_cache
850 set_stuff_for_environment
851 printconfig
852 destroy_build_var_cache
853}
854
Matt Alexanderd9c56562020-05-21 10:49:17 +0000855function gettop
856{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700857 local TOPFILE=build/make/core/envsetup.mk
Matt Alexanderd9c56562020-05-21 10:49:17 +0000858 if [ -n "$TOP" -a -f "$TOP/$TOPFILE" ] ; then
Brian Carlstroma5c4f172014-09-12 00:33:25 -0700859 # The following circumlocution ensures we remove symlinks from TOP.
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000860 (cd "$TOP"; PWD= /bin/pwd)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700861 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000862 if [ -f $TOPFILE ] ; then
Dan Bornsteind0b274d2009-11-24 15:48:50 -0800863 # The following circumlocution (repeated below as well) ensures
864 # that we record the true directory name and not one that is
865 # faked up with symlink names.
866 PWD= /bin/pwd
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700867 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800868 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700869 local T=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000870 while [ \( ! \( -f $TOPFILE \) \) -a \( "$PWD" != "/" \) ]; do
Ying Wang9cd17642012-12-13 10:52:07 -0800871 \cd ..
synergyb112a402013-07-05 19:47:47 -0700872 T=`PWD= /bin/pwd -P`
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700873 done
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000874 \cd "$HERE"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700875 if [ -f "$T/$TOPFILE" ]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000876 echo "$T"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700877 fi
878 fi
879 fi
880}
881
Matt Alexanderd9c56562020-05-21 10:49:17 +0000882function croot()
883{
Christopher Ferris55257d22017-03-23 11:08:58 -0700884 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700885 if [ "$T" ]; then
Marie Janssen32ec50a2016-04-21 16:53:39 -0700886 if [ "$1" ]; then
887 \cd $(gettop)/$1
888 else
889 \cd $(gettop)
890 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700891 else
892 echo "Couldn't locate the top of the tree. Try setting TOP."
893 fi
894}
895
Matt Alexanderd9c56562020-05-21 10:49:17 +0000896function _croot()
897{
Anton Hanssonece9c482019-02-04 18:15:39 +0000898 local T=$(gettop)
899 if [ "$T" ]; then
900 local cur="${COMP_WORDS[COMP_CWORD]}"
901 k=0
902 for c in $(compgen -d ${T}/${cur}); do
903 COMPREPLY[k++]=${c#${T}/}/
904 done
905 fi
906}
907
Matt Alexanderd9c56562020-05-21 10:49:17 +0000908function cproj()
909{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700910 local TOPFILE=build/make/core/envsetup.mk
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700911 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700912 local T=
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700913 while [ \( ! \( -f $TOPFILE \) \) -a \( $PWD != "/" \) ]; do
914 T=$PWD
915 if [ -f "$T/Android.mk" ]; then
Ying Wang9cd17642012-12-13 10:52:07 -0800916 \cd $T
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700917 return
918 fi
Ying Wang9cd17642012-12-13 10:52:07 -0800919 \cd ..
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700920 done
Ying Wang9cd17642012-12-13 10:52:07 -0800921 \cd $HERE
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700922 echo "can't find Android.mk"
923}
924
Daniel Sandler47e0a882013-07-30 13:23:52 -0400925# simplified version of ps; output in the form
926# <pid> <procname>
927function qpid() {
928 local prepend=''
929 local append=''
Matt Alexanderd9c56562020-05-21 10:49:17 +0000930 if [ "$1" = "--exact" ]; then
Daniel Sandler47e0a882013-07-30 13:23:52 -0400931 prepend=' '
932 append='$'
933 shift
Matt Alexanderd9c56562020-05-21 10:49:17 +0000934 elif [ "$1" = "--help" -o "$1" = "-h" ]; then
Ying Wang08800fd2016-03-03 20:57:21 -0800935 echo "usage: qpid [[--exact] <process name|pid>"
936 return 255
937 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -0400938
939 local EXE="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +0000940 if [ "$EXE" ] ; then
Ying Wang08800fd2016-03-03 20:57:21 -0800941 qpid | \grep "$prepend$EXE$append"
942 else
943 adb shell ps \
944 | tr -d '\r' \
945 | sed -e 1d -e 's/^[^ ]* *\([0-9]*\).* \([^ ]*\)$/\1 \2/'
946 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -0400947}
948
Steven Moreland74114f12020-09-10 01:23:32 +0000949# syswrite - disable verity, reboot if needed, and remount image
950#
951# Easy way to make system.img/etc writable
952function syswrite() {
953 adb wait-for-device && adb root || return 1
954 if [[ $(adb disable-verity | grep "reboot") ]]; then
955 echo "rebooting"
956 adb reboot && adb wait-for-device && adb root || return 1
957 fi
958 adb wait-for-device && adb remount || return 1
959}
960
Iliyan Malcheve675cfb2014-11-03 17:04:47 -0800961# coredump_setup - enable core dumps globally for any process
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700962# that has the core-file-size limit set correctly
963#
Iliyan Malchevaf5de972014-11-04 20:57:37 -0800964# NOTE: You must call also coredump_enable for a specific process
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700965# if its core-file-size limit is not set already.
966# NOTE: Core dumps are written to ramdisk; they will not survive a reboot!
967
Matt Alexanderd9c56562020-05-21 10:49:17 +0000968function coredump_setup()
969{
970 echo "Getting root...";
971 adb root;
972 adb wait-for-device;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700973
Matt Alexanderd9c56562020-05-21 10:49:17 +0000974 echo "Remounting root partition read-write...";
975 adb shell mount -w -o remount -t rootfs rootfs;
976 sleep 1;
977 adb wait-for-device;
978 adb shell mkdir -p /cores;
979 adb shell mount -t tmpfs tmpfs /cores;
980 adb shell chmod 0777 /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700981
Matt Alexanderd9c56562020-05-21 10:49:17 +0000982 echo "Granting SELinux permission to dump in /cores...";
983 adb shell restorecon -R /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700984
Matt Alexanderd9c56562020-05-21 10:49:17 +0000985 echo "Set core pattern.";
986 adb shell 'echo /cores/core.%p > /proc/sys/kernel/core_pattern';
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700987
Ying Wang08800fd2016-03-03 20:57:21 -0800988 echo "Done."
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700989}
990
Iliyan Malchevaf5de972014-11-04 20:57:37 -0800991# coredump_enable - enable core dumps for the specified process
Matt Alexanderd9c56562020-05-21 10:49:17 +0000992# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700993#
Iliyan Malchevaf5de972014-11-04 20:57:37 -0800994# NOTE: coredump_setup must have been called as well for a core
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700995# dump to actually be generated.
996
Matt Alexanderd9c56562020-05-21 10:49:17 +0000997function coredump_enable()
998{
999 local PID=$1;
Ying Wang08800fd2016-03-03 20:57:21 -08001000 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001001 printf "Expecting a PID!\n";
1002 return;
1003 fi;
1004 echo "Setting core limit for $PID to infinite...";
Elliott Hughes910a3552016-03-07 13:53:53 -08001005 adb shell /system/bin/ulimit -p $PID -c unlimited
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001006}
1007
1008# core - send SIGV and pull the core for process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001009# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001010#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001011# NOTE: coredump_setup must be called once per boot for core dumps to be
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001012# enabled globally.
1013
Matt Alexanderd9c56562020-05-21 10:49:17 +00001014function core()
1015{
1016 local PID=$1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001017
Ying Wang08800fd2016-03-03 20:57:21 -08001018 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001019 printf "Expecting a PID!\n";
1020 return;
1021 fi;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001022
Matt Alexanderd9c56562020-05-21 10:49:17 +00001023 local CORENAME=core.$PID;
1024 local COREPATH=/cores/$CORENAME;
1025 local SIG=SEGV;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001026
Matt Alexanderd9c56562020-05-21 10:49:17 +00001027 coredump_enable $1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001028
Matt Alexanderd9c56562020-05-21 10:49:17 +00001029 local done=0;
Ying Wang08800fd2016-03-03 20:57:21 -08001030 while [ $(adb shell "[ -d /proc/$PID ] && echo -n yes") ]; do
Matt Alexanderd9c56562020-05-21 10:49:17 +00001031 printf "\tSending SIG%s to %d...\n" $SIG $PID;
1032 adb shell kill -$SIG $PID;
1033 sleep 1;
1034 done;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001035
Matt Alexanderd9c56562020-05-21 10:49:17 +00001036 adb shell "while [ ! -f $COREPATH ] ; do echo waiting for $COREPATH to be generated; sleep 1; done"
1037 echo "Done: core is under $COREPATH on device.";
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001038}
1039
Christopher Tate744ee802009-11-12 15:33:08 -08001040# systemstack - dump the current stack trace of all threads in the system process
1041# to the usual ANR traces file
Matt Alexanderd9c56562020-05-21 10:49:17 +00001042function systemstack()
1043{
Jeff Sharkeyf5824372013-02-19 17:00:46 -08001044 stacks system_server
1045}
1046
Michael Wrightaeed7212014-06-19 19:58:12 -07001047# Read the ELF header from /proc/$PID/exe to determine if the process is
1048# 64-bit.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001049function is64bit()
1050{
Ben Chengfba67bf2014-02-25 10:27:07 -08001051 local PID="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +00001052 if [ "$PID" ] ; then
1053 if [[ "$(adb shell cat /proc/$PID/exe | xxd -l 1 -s 4 -p)" -eq "02" ]] ; then
Ben Chengfba67bf2014-02-25 10:27:07 -08001054 echo "64"
1055 else
1056 echo ""
1057 fi
1058 else
1059 echo ""
1060 fi
1061}
1062
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001063case `uname -s` in
1064 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001065 function sgrep()
1066 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001067 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cc|cpp|hpp|S|java|kt|xml|sh|mk|aidl|vts|proto)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001068 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001069 }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001070
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001071 ;;
1072 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001073 function sgrep()
1074 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001075 find . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.\(c\|h\|cc\|cpp\|hpp\|S\|java\|kt\|xml\|sh\|mk\|aidl\|vts\|proto\)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001076 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001077 }
1078 ;;
1079esac
1080
Matt Alexanderd9c56562020-05-21 10:49:17 +00001081function gettargetarch
1082{
Raghu Gandham8da43102012-07-25 19:57:22 -07001083 get_build_var TARGET_ARCH
1084}
1085
Matt Alexanderd9c56562020-05-21 10:49:17 +00001086function ggrep()
1087{
Mike Frysinger5e479732015-09-22 18:13:48 -04001088 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.gradle" \
1089 -exec grep --color -n "$@" {} +
Jon Boekenoogencbca56f2014-04-07 10:57:38 -07001090}
1091
Matt Alexanderd9c56562020-05-21 10:49:17 +00001092function gogrep()
1093{
Orion Hodson831472d2019-10-25 11:35:15 +01001094 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.go" \
1095 -exec grep --color -n "$@" {} +
1096}
1097
Matt Alexanderd9c56562020-05-21 10:49:17 +00001098function jgrep()
1099{
Mike Frysinger5e479732015-09-22 18:13:48 -04001100 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.java" \
1101 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001102}
1103
Alistair Delva176e5342021-02-22 13:31:26 -08001104function rsgrep()
Jeff Vander Stoep1431ab82021-02-02 19:18:26 +01001105{
1106 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rs" \
1107 -exec grep --color -n "$@" {} +
1108}
1109
Taesu Leeea0cecd2020-10-28 11:05:18 +09001110function ktgrep()
1111{
1112 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.kt" \
1113 -exec grep --color -n "$@" {} +
1114}
1115
Matt Alexanderd9c56562020-05-21 10:49:17 +00001116function cgrep()
1117{
Mike Frysinger5e479732015-09-22 18:13:48 -04001118 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f \( -name '*.c' -o -name '*.cc' -o -name '*.cpp' -o -name '*.h' -o -name '*.hpp' \) \
1119 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001120}
1121
Matt Alexanderd9c56562020-05-21 10:49:17 +00001122function resgrep()
1123{
Christopher Ferris55257d22017-03-23 11:08:58 -07001124 local dir
Mike Frysinger5e479732015-09-22 18:13:48 -04001125 for dir in `find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -name res -type d`; do
1126 find $dir -type f -name '*\.xml' -exec grep --color -n "$@" {} +
1127 done
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001128}
1129
Matt Alexanderd9c56562020-05-21 10:49:17 +00001130function mangrep()
1131{
Mike Frysinger5e479732015-09-22 18:13:48 -04001132 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'AndroidManifest.xml' \
1133 -exec grep --color -n "$@" {} +
Jeff Sharkey50b61e92013-03-08 10:20:47 -08001134}
1135
Matt Alexanderd9c56562020-05-21 10:49:17 +00001136function owngrep()
1137{
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -06001138 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'OWNERS' \
1139 -exec grep --color -n "$@" {} +
1140}
1141
Matt Alexanderd9c56562020-05-21 10:49:17 +00001142function sepgrep()
1143{
Mike Frysinger5e479732015-09-22 18:13:48 -04001144 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -name sepolicy -type d \
1145 -exec grep --color -n -r --exclude-dir=\.git "$@" {} +
Alex Klyubinba5fc8e2013-05-06 14:11:48 -07001146}
1147
Matt Alexanderd9c56562020-05-21 10:49:17 +00001148function rcgrep()
1149{
Mike Frysinger5e479732015-09-22 18:13:48 -04001150 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rc*" \
1151 -exec grep --color -n "$@" {} +
Jeff Sharkeyea0068a2015-02-26 14:13:46 -08001152}
1153
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001154case `uname -s` in
1155 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001156 function mgrep()
1157 {
Orion Hodson831472d2019-10-25 11:35:15 +01001158 find -E . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -iregex '.*/(Makefile|Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001159 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001160 }
1161
Matt Alexanderd9c56562020-05-21 10:49:17 +00001162 function treegrep()
1163 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001164 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001165 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001166 }
1167
1168 ;;
1169 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001170 function mgrep()
1171 {
Orion Hodson831472d2019-10-25 11:35:15 +01001172 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -regextype posix-egrep -iregex '(.*\/Makefile|.*\/Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regextype posix-extended -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001173 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001174 }
1175
Matt Alexanderd9c56562020-05-21 10:49:17 +00001176 function treegrep()
1177 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001178 find . -name .repo -prune -o -name .git -prune -o -regextype posix-egrep -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001179 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001180 }
1181
1182 ;;
1183esac
1184
Matt Alexanderd9c56562020-05-21 10:49:17 +00001185function getprebuilt
1186{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001187 get_abs_build_var ANDROID_PREBUILTS
1188}
1189
Matt Alexanderd9c56562020-05-21 10:49:17 +00001190function tracedmdump()
1191{
Christopher Ferris55257d22017-03-23 11:08:58 -07001192 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001193 if [ ! "$T" ]; then
1194 echo "Couldn't locate the top of the tree. Try setting TOP."
1195 return
1196 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001197 local prebuiltdir=$(getprebuilt)
Raghu Gandham8da43102012-07-25 19:57:22 -07001198 local arch=$(gettargetarch)
1199 local KERNEL=$T/prebuilts/qemu-kernel/$arch/vmlinux-qemu
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001200
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001201 local TRACE=$1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001202 if [ ! "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001203 echo "usage: tracedmdump tracename"
1204 return
1205 fi
1206
Matt Alexanderd9c56562020-05-21 10:49:17 +00001207 if [ ! -r "$KERNEL" ] ; then
Jack Veenstra60116fc2009-04-09 18:12:34 -07001208 echo "Error: cannot find kernel: '$KERNEL'"
1209 return
1210 fi
1211
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001212 local BASETRACE=$(basename $TRACE)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001213 if [ "$BASETRACE" = "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001214 TRACE=$ANDROID_PRODUCT_OUT/traces/$TRACE
1215 fi
1216
1217 echo "post-processing traces..."
1218 rm -f $TRACE/qtrace.dexlist
1219 post_trace $TRACE
1220 if [ $? -ne 0 ]; then
1221 echo "***"
1222 echo "*** Error: malformed trace. Did you remember to exit the emulator?"
1223 echo "***"
1224 return
1225 fi
1226 echo "generating dexlist output..."
1227 /bin/ls $ANDROID_PRODUCT_OUT/system/framework/*.jar $ANDROID_PRODUCT_OUT/system/app/*.apk $ANDROID_PRODUCT_OUT/data/app/*.apk 2>/dev/null | xargs dexlist > $TRACE/qtrace.dexlist
1228 echo "generating dmtrace data..."
1229 q2dm -r $ANDROID_PRODUCT_OUT/symbols $TRACE $KERNEL $TRACE/dmtrace || return
1230 echo "generating html file..."
1231 dmtracedump -h $TRACE/dmtrace >| $TRACE/dmtrace.html || return
1232 echo "done, see $TRACE/dmtrace.html for details"
1233 echo "or run:"
1234 echo " traceview $TRACE/dmtrace"
1235}
1236
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001237# communicate with a running device or emulator, set up necessary state,
1238# and run the hat command.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001239function runhat()
1240{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001241 # process standard adb options
1242 local adbTarget=""
Matt Alexanderd9c56562020-05-21 10:49:17 +00001243 if [ "$1" = "-d" -o "$1" = "-e" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001244 adbTarget=$1
1245 shift 1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001246 elif [ "$1" = "-s" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001247 adbTarget="$1 $2"
1248 shift 2
1249 fi
1250 local adbOptions=${adbTarget}
Matt Alexanderd9c56562020-05-21 10:49:17 +00001251 #echo adbOptions = ${adbOptions}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001252
1253 # runhat options
1254 local targetPid=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001255
Matt Alexanderd9c56562020-05-21 10:49:17 +00001256 if [ "$targetPid" = "" ]; then
Andy McFaddenb6289852010-07-12 08:00:19 -07001257 echo "Usage: runhat [ -d | -e | -s serial ] target-pid"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001258 return
1259 fi
1260
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001261 # confirm hat is available
1262 if [ -z $(which hat) ]; then
1263 echo "hat is not available in this configuration."
1264 return
1265 fi
1266
Andy McFaddenb6289852010-07-12 08:00:19 -07001267 # issue "am" command to cause the hprof dump
Nick Kralevich9948b1e2014-07-18 15:45:38 -07001268 local devFile=/data/local/tmp/hprof-$targetPid
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001269 echo "Poking $targetPid and waiting for data..."
Dianne Hackborn6b9549f2012-09-26 15:00:59 -07001270 echo "Storing data at $devFile"
Andy McFaddenb6289852010-07-12 08:00:19 -07001271 adb ${adbOptions} shell am dumpheap $targetPid $devFile
The Android Open Source Project88b60792009-03-03 19:28:42 -08001272 echo "Press enter when logcat shows \"hprof: heap dump completed\""
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001273 echo -n "> "
1274 read
1275
The Android Open Source Project88b60792009-03-03 19:28:42 -08001276 local localFile=/tmp/$$-hprof
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001277
The Android Open Source Project88b60792009-03-03 19:28:42 -08001278 echo "Retrieving file $devFile..."
1279 adb ${adbOptions} pull $devFile $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001280
The Android Open Source Project88b60792009-03-03 19:28:42 -08001281 adb ${adbOptions} shell rm $devFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001282
The Android Open Source Project88b60792009-03-03 19:28:42 -08001283 echo "Running hat on $localFile"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001284 echo "View the output by pointing your browser at http://localhost:7000/"
1285 echo ""
Dianne Hackborn6e4e1bb2011-11-10 15:19:51 -08001286 hat -JXmx512m $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001287}
1288
Matt Alexanderd9c56562020-05-21 10:49:17 +00001289function getbugreports()
1290{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001291 local reports=(`adb shell ls /sdcard/bugreports | tr -d '\r'`)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001292
1293 if [ ! "$reports" ]; then
1294 echo "Could not locate any bugreports."
1295 return
1296 fi
1297
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001298 local report
1299 for report in ${reports[@]}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001300 do
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001301 echo "/sdcard/bugreports/${report}"
1302 adb pull /sdcard/bugreports/${report} ${report}
1303 gunzip ${report}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001304 done
1305}
1306
Matt Alexanderd9c56562020-05-21 10:49:17 +00001307function getsdcardpath()
1308{
Victoria Lease1b296b42012-08-21 15:44:06 -07001309 adb ${adbOptions} shell echo -n \$\{EXTERNAL_STORAGE\}
1310}
1311
Matt Alexanderd9c56562020-05-21 10:49:17 +00001312function getscreenshotpath()
1313{
Victoria Lease1b296b42012-08-21 15:44:06 -07001314 echo "$(getsdcardpath)/Pictures/Screenshots"
1315}
1316
Matt Alexanderd9c56562020-05-21 10:49:17 +00001317function getlastscreenshot()
1318{
Victoria Lease1b296b42012-08-21 15:44:06 -07001319 local screenshot_path=$(getscreenshotpath)
1320 local screenshot=`adb ${adbOptions} ls ${screenshot_path} | grep Screenshot_[0-9-]*.*\.png | sort -rk 3 | cut -d " " -f 4 | head -n 1`
Matt Alexanderd9c56562020-05-21 10:49:17 +00001321 if [ "$screenshot" = "" ]; then
Victoria Lease1b296b42012-08-21 15:44:06 -07001322 echo "No screenshots found."
1323 return
1324 fi
1325 echo "${screenshot}"
1326 adb ${adbOptions} pull ${screenshot_path}/${screenshot}
1327}
1328
Matt Alexanderd9c56562020-05-21 10:49:17 +00001329function startviewserver()
1330{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001331 local port=4939
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001332 if [ $# -gt 0 ]; then
1333 port=$1
1334 fi
1335 adb shell service call window 1 i32 $port
1336}
1337
Matt Alexanderd9c56562020-05-21 10:49:17 +00001338function stopviewserver()
1339{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001340 adb shell service call window 2
1341}
1342
Matt Alexanderd9c56562020-05-21 10:49:17 +00001343function isviewserverstarted()
1344{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001345 adb shell service call window 3
1346}
1347
Matt Alexanderd9c56562020-05-21 10:49:17 +00001348function key_home()
1349{
Romain Guyb84049a2010-10-04 16:56:11 -07001350 adb shell input keyevent 3
1351}
1352
Matt Alexanderd9c56562020-05-21 10:49:17 +00001353function key_back()
1354{
Romain Guyb84049a2010-10-04 16:56:11 -07001355 adb shell input keyevent 4
1356}
1357
Matt Alexanderd9c56562020-05-21 10:49:17 +00001358function key_menu()
1359{
Romain Guyb84049a2010-10-04 16:56:11 -07001360 adb shell input keyevent 82
1361}
1362
Matt Alexanderd9c56562020-05-21 10:49:17 +00001363function smoketest()
1364{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001365 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1366 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1367 return
1368 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001369 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001370 if [ ! "$T" ]; then
1371 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1372 return
1373 fi
1374
Ying Wang9cd17642012-12-13 10:52:07 -08001375 (\cd "$T" && mmm tests/SmokeTest) &&
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001376 adb uninstall com.android.smoketest > /dev/null &&
1377 adb uninstall com.android.smoketest.tests > /dev/null &&
1378 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTestApp.apk &&
1379 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTest.apk &&
1380 adb shell am instrument -w com.android.smoketest.tests/android.test.InstrumentationTestRunner
1381}
1382
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001383# simple shortcut to the runtest command
Matt Alexanderd9c56562020-05-21 10:49:17 +00001384function runtest()
1385{
Christopher Ferris55257d22017-03-23 11:08:58 -07001386 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001387 if [ ! "$T" ]; then
1388 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1389 return
1390 fi
Brett Chabot3fb149d2009-10-21 20:05:26 -07001391 ("$T"/development/testrunner/runtest.py $@)
Brett Chabot762748c2009-03-27 10:25:11 -07001392}
1393
The Android Open Source Project88b60792009-03-03 19:28:42 -08001394function godir () {
1395 if [[ -z "$1" ]]; then
1396 echo "Usage: godir <regex>"
1397 return
1398 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001399 local T=$(gettop)
1400 local FILELIST
Matt Alexanderd9c56562020-05-21 10:49:17 +00001401 if [ ! "$OUT_DIR" = "" ]; then
Brian Carlstromf2257422015-09-30 20:28:54 -07001402 mkdir -p $OUT_DIR
1403 FILELIST=$OUT_DIR/filelist
1404 else
1405 FILELIST=$T/filelist
1406 fi
1407 if [[ ! -f $FILELIST ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001408 echo -n "Creating index..."
Brian Carlstromf2257422015-09-30 20:28:54 -07001409 (\cd $T; find . -wholename ./out -prune -o -wholename ./.repo -prune -o -type f > $FILELIST)
The Android Open Source Project88b60792009-03-03 19:28:42 -08001410 echo " Done"
1411 echo ""
1412 fi
1413 local lines
Brian Carlstromf2257422015-09-30 20:28:54 -07001414 lines=($(\grep "$1" $FILELIST | sed -e 's/\/[^/]*$//' | sort | uniq))
Matt Alexanderd9c56562020-05-21 10:49:17 +00001415 if [[ ${#lines[@]} = 0 ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001416 echo "Not found"
1417 return
1418 fi
1419 local pathname
1420 local choice
1421 if [[ ${#lines[@]} > 1 ]]; then
1422 while [[ -z "$pathname" ]]; do
1423 local index=1
1424 local line
1425 for line in ${lines[@]}; do
1426 printf "%6s %s\n" "[$index]" $line
Doug Zongker29034982011-04-22 08:16:56 -07001427 index=$(($index + 1))
The Android Open Source Project88b60792009-03-03 19:28:42 -08001428 done
1429 echo
1430 echo -n "Select one: "
1431 unset choice
1432 read choice
1433 if [[ $choice -gt ${#lines[@]} || $choice -lt 1 ]]; then
1434 echo "Invalid choice"
1435 continue
1436 fi
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001437 pathname=${lines[@]:$(($choice-1)):1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001438 done
1439 else
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001440 pathname=${lines[@]:0:1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001441 fi
Ying Wang9cd17642012-12-13 10:52:07 -08001442 \cd $T/$pathname
The Android Open Source Project88b60792009-03-03 19:28:42 -08001443}
1444
Steven Moreland62054a42018-12-06 10:11:40 -08001445# Update module-info.json in out.
1446function refreshmod() {
1447 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1448 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1449 return 1
1450 fi
1451
1452 echo "Refreshing modules (building module-info.json). Log at $ANDROID_PRODUCT_OUT/module-info.json.build.log." >&2
1453
1454 # for the output of the next command
1455 mkdir -p $ANDROID_PRODUCT_OUT || return 1
1456
1457 # Note, can't use absolute path because of the way make works.
Alessandro Astonec8771be2020-05-10 11:27:57 +02001458 m $(get_build_var PRODUCT_OUT)/module-info.json \
Steven Moreland62054a42018-12-06 10:11:40 -08001459 > $ANDROID_PRODUCT_OUT/module-info.json.build.log 2>&1
1460}
1461
Cole Faust24c36db2021-01-23 02:39:37 +00001462# Verifies that module-info.txt exists, creating it if it doesn't.
1463function verifymodinfo() {
Steven Moreland62054a42018-12-06 10:11:40 -08001464 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001465 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
1466 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1467 fi
Steven Moreland62054a42018-12-06 10:11:40 -08001468 return 1
1469 fi
1470
1471 if [ ! -f "$ANDROID_PRODUCT_OUT/module-info.json" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001472 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
1473 echo "Could not find module-info.json. It will only be built once, and it can be updated with 'refreshmod'" >&2
1474 fi
1475 return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001476 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001477}
1478
1479# List all modules for the current device, as cached in module-info.json. If any build change is
1480# made and it should be reflected in the output, you should run 'refreshmod' first.
1481function allmod() {
1482 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001483
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001484 python3 -c "import json; print('\n'.join(sorted(json.load(open('$ANDROID_PRODUCT_OUT/module-info.json')).keys())))"
Steven Moreland62054a42018-12-06 10:11:40 -08001485}
1486
Joe Onorato2c1aa472021-02-25 16:42:39 -08001487# Get the path of a specific module in the android tree, as cached in module-info.json.
1488# If any build change is made, and it should be reflected in the output, you should run
1489# 'refreshmod' first. Note: This is the inverse of dirmods.
Rett Berg78d1c932019-01-24 14:34:23 -08001490function pathmod() {
Steven Moreland62054a42018-12-06 10:11:40 -08001491 if [[ $# -ne 1 ]]; then
Rett Berg78d1c932019-01-24 14:34:23 -08001492 echo "usage: pathmod <module>" >&2
Steven Moreland62054a42018-12-06 10:11:40 -08001493 return 1
1494 fi
1495
Cole Faust24c36db2021-01-23 02:39:37 +00001496 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001497
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001498 local relpath=$(python3 -c "import json, os
Steven Moreland62054a42018-12-06 10:11:40 -08001499module = '$1'
1500module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1501if module not in module_info:
1502 exit(1)
LuK1337b6a78192020-01-12 03:12:17 +01001503print(module_info[module]['path'][0])" 2>/dev/null)
Steven Moreland62054a42018-12-06 10:11:40 -08001504
1505 if [ -z "$relpath" ]; then
1506 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)." >&2
1507 return 1
1508 else
Rett Berg78d1c932019-01-24 14:34:23 -08001509 echo "$ANDROID_BUILD_TOP/$relpath"
Steven Moreland62054a42018-12-06 10:11:40 -08001510 fi
1511}
1512
Joe Onorato2c1aa472021-02-25 16:42:39 -08001513# Get the path of a specific module in the android tree, as cached in module-info.json.
1514# If any build change is made, and it should be reflected in the output, you should run
1515# 'refreshmod' first. Note: This is the inverse of pathmod.
1516function dirmods() {
1517 if [[ $# -ne 1 ]]; then
1518 echo "usage: dirmods <path>" >&2
1519 return 1
1520 fi
1521
1522 verifymodinfo || return 1
1523
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001524 python3 -c "import json, os
Joe Onorato2c1aa472021-02-25 16:42:39 -08001525dir = '$1'
1526while dir.endswith('/'):
1527 dir = dir[:-1]
1528prefix = dir + '/'
1529module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1530results = set()
1531for m in module_info.values():
1532 for path in m.get(u'path', []):
1533 if path == dir or path.startswith(prefix):
1534 name = m.get(u'module_name')
1535 if name:
1536 results.add(name)
1537for name in sorted(results):
1538 print(name)
1539"
1540}
1541
1542
Rett Berg78d1c932019-01-24 14:34:23 -08001543# Go to a specific module in the android tree, as cached in module-info.json. If any build change
1544# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1545function gomod() {
1546 if [[ $# -ne 1 ]]; then
1547 echo "usage: gomod <module>" >&2
1548 return 1
1549 fi
1550
1551 local path="$(pathmod $@)"
1552 if [ -z "$path" ]; then
1553 return 1
1554 fi
1555 cd $path
1556}
1557
Cole Faust24c36db2021-01-23 02:39:37 +00001558# Gets the list of a module's installed outputs, as cached in module-info.json.
1559# If any build change is made, and it should be reflected in the output, you should run 'refreshmod' first.
1560function outmod() {
1561 if [[ $# -ne 1 ]]; then
1562 echo "usage: outmod <module>" >&2
1563 return 1
1564 fi
1565
1566 verifymodinfo || return 1
1567
1568 local relpath
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001569 relpath=$(python3 -c "import json, os
Cole Faust24c36db2021-01-23 02:39:37 +00001570module = '$1'
1571module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1572if module not in module_info:
1573 exit(1)
1574for output in module_info[module]['installed']:
1575 print(os.path.join('$ANDROID_BUILD_TOP', output))" 2>/dev/null)
1576
1577 if [ $? -ne 0 ]; then
1578 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)" >&2
1579 return 1
1580 elif [ ! -z "$relpath" ]; then
1581 echo "$relpath"
1582 fi
1583}
1584
1585# adb install a module's apk, as cached in module-info.json. If any build change
1586# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1587# Usage: installmod [adb install arguments] <module>
1588# For example: installmod -r Dialer -> adb install -r /path/to/Dialer.apk
1589function installmod() {
1590 if [[ $# -eq 0 ]]; then
1591 echo "usage: installmod [adb install arguments] <module>" >&2
1592 return 1
1593 fi
1594
1595 local _path
1596 _path=$(outmod ${@:$#:1})
1597 if [ $? -ne 0 ]; then
1598 return 1
1599 fi
1600
1601 _path=$(echo "$_path" | grep -E \\.apk$ | head -n 1)
1602 if [ -z "$_path" ]; then
1603 echo "Module '$1' does not produce a file ending with .apk (try 'refreshmod' if there have been build changes?)" >&2
1604 return 1
1605 fi
1606 local length=$(( $# - 1 ))
1607 echo adb install ${@:1:$length} $_path
1608 adb install ${@:1:$length} $_path
1609}
1610
dimitry73b84812018-12-11 18:06:00 +01001611function _complete_android_module_names() {
Steven Moreland62054a42018-12-06 10:11:40 -08001612 local word=${COMP_WORDS[COMP_CWORD]}
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001613 COMPREPLY=( $(QUIET_VERIFYMODINFO=true allmod | grep -E "^$word") )
Steven Moreland62054a42018-12-06 10:11:40 -08001614}
1615
Alex Rayf0d08eb2013-03-08 15:15:06 -08001616# Print colored exit condition
1617function pez {
Michael Wrighteb733842013-03-08 17:34:02 -08001618 "$@"
1619 local retval=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +00001620 if [ $retval -ne 0 ]
1621 then
Jacky Cao89483b82015-05-15 22:12:53 +08001622 echo $'\E'"[0;31mFAILURE\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001623 else
Jacky Cao89483b82015-05-15 22:12:53 +08001624 echo $'\E'"[0;32mSUCCESS\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001625 fi
1626 return $retval
Alex Rayf0d08eb2013-03-08 15:15:06 -08001627}
1628
Matt Alexanderd9c56562020-05-21 10:49:17 +00001629function get_make_command()
1630{
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001631 # If we're in the top of an Android tree, use soong_ui.bash instead of make
1632 if [ -f build/soong/soong_ui.bash ]; then
Dan Willemsene9842242017-07-28 13:00:13 -07001633 # Always use the real make if -C is passed in
1634 for arg in "$@"; do
1635 if [[ $arg == -C* ]]; then
1636 echo command make
1637 return
1638 fi
1639 done
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001640 echo build/soong/soong_ui.bash --make-mode
1641 else
1642 echo command make
1643 fi
Ying Wanged21d4c2014-08-24 22:14:19 -07001644}
1645
Matt Alexanderd9c56562020-05-21 10:49:17 +00001646function _wrap_build()
1647{
Sasha Smundak9f27cc02019-01-31 13:25:31 -08001648 if [[ "${ANDROID_QUIET_BUILD:-}" == true ]]; then
1649 "$@"
1650 return $?
1651 fi
Ed Heylcc6be0a2014-06-18 14:55:58 -07001652 local start_time=$(date +"%s")
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001653 "$@"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001654 local ret=$?
1655 local end_time=$(date +"%s")
1656 local tdiff=$(($end_time-$start_time))
1657 local hours=$(($tdiff / 3600 ))
1658 local mins=$((($tdiff % 3600) / 60))
1659 local secs=$(($tdiff % 60))
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001660 local ncolors=$(tput colors 2>/dev/null)
1661 if [ -n "$ncolors" ] && [ $ncolors -ge 8 ]; then
Jacky Cao89483b82015-05-15 22:12:53 +08001662 color_failed=$'\E'"[0;31m"
1663 color_success=$'\E'"[0;32m"
1664 color_reset=$'\E'"[00m"
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001665 else
1666 color_failed=""
1667 color_success=""
1668 color_reset=""
1669 fi
Ed Heylcc6be0a2014-06-18 14:55:58 -07001670 echo
Matt Alexanderd9c56562020-05-21 10:49:17 +00001671 if [ $ret -eq 0 ] ; then
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001672 echo -n "${color_success}#### build completed successfully "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001673 else
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001674 echo -n "${color_failed}#### failed to build some targets "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001675 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +00001676 if [ $hours -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001677 printf "(%02g:%02g:%02g (hh:mm:ss))" $hours $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001678 elif [ $mins -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001679 printf "(%02g:%02g (mm:ss))" $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001680 elif [ $secs -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001681 printf "(%s seconds)" $secs
1682 fi
Jacky Cao89483b82015-05-15 22:12:53 +08001683 echo " ####${color_reset}"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001684 echo
1685 return $ret
1686}
1687
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001688function _trigger_build()
1689(
1690 local -r bc="$1"; shift
1691 if T="$(gettop)"; then
1692 _wrap_build "$T/build/soong/soong_ui.bash" --build-mode --${bc} --dir="$(pwd)" "$@"
1693 else
Jingwen Chend728ee12021-05-18 06:02:53 +00001694 >&2 echo "Couldn't locate the top of the tree. Try setting TOP."
1695 return 1
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001696 fi
1697)
1698
Jingwen Chend728ee12021-05-18 06:02:53 +00001699function b()
1700(
1701 # Generate BUILD, bzl files into the synthetic Bazel workspace (out/soong/workspace).
1702 m nothing GENERATE_BAZEL_FILES=true || return 1
1703 # Then, run Bazel using the synthetic workspace as the --package_path.
1704 "$(gettop)/tools/bazel" "$@" --config=bp2build
1705)
1706
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001707function m()
1708(
1709 _trigger_build "all-modules" "$@"
1710)
1711
1712function mm()
1713(
1714 _trigger_build "modules-in-a-dir-no-deps" "$@"
1715)
1716
1717function mmm()
1718(
1719 _trigger_build "modules-in-dirs-no-deps" "$@"
1720)
1721
1722function mma()
1723(
1724 _trigger_build "modules-in-a-dir" "$@"
1725)
1726
1727function mmma()
1728(
1729 _trigger_build "modules-in-dirs" "$@"
1730)
1731
Matt Alexanderd9c56562020-05-21 10:49:17 +00001732function make()
1733{
Dan Willemsene9842242017-07-28 13:00:13 -07001734 _wrap_build $(get_make_command "$@") "$@"
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001735}
1736
Matt Alexanderd9c56562020-05-21 10:49:17 +00001737function provision()
1738{
David Zeuthen1b126ff2015-09-30 17:10:48 -04001739 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1740 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1741 return 1
1742 fi
1743 if [ ! -e "$ANDROID_PRODUCT_OUT/provision-device" ]; then
1744 echo "There is no provisioning script for the device." >&2
1745 return 1
1746 fi
1747
1748 # Check if user really wants to do this.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001749 if [ "$1" = "--no-confirmation" ]; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001750 shift 1
1751 else
1752 echo "This action will reflash your device."
1753 echo ""
1754 echo "ALL DATA ON THE DEVICE WILL BE IRREVOCABLY ERASED."
1755 echo ""
Marie Janssen4afc2c02015-11-10 10:41:15 -08001756 echo -n "Are you sure you want to do this (yes/no)? "
1757 read
Matt Alexanderd9c56562020-05-21 10:49:17 +00001758 if [[ "${REPLY}" != "yes" ]] ; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001759 echo "Not taking any action. Exiting." >&2
1760 return 1
1761 fi
1762 fi
1763 "$ANDROID_PRODUCT_OUT/provision-device" "$@"
1764}
1765
Jim Tanga881a252018-06-19 16:34:41 +08001766# Zsh needs bashcompinit called to support bash-style completion.
Patrik Fimmldf248e62018-10-15 18:15:12 +02001767function enable_zsh_completion() {
1768 # Don't override user's options if bash-style completion is already enabled.
1769 if ! declare -f complete >/dev/null; then
1770 autoload -U compinit && compinit
1771 autoload -U bashcompinit && bashcompinit
1772 fi
Jim Tanga881a252018-06-19 16:34:41 +08001773}
1774
1775function validate_current_shell() {
1776 local current_sh="$(ps -o command -p $$)"
1777 case "$current_sh" in
Raphael Moll70a86b02011-06-20 16:03:14 -07001778 *bash*)
Jim Tanga881a252018-06-19 16:34:41 +08001779 function check_type() { type -t "$1"; }
Raphael Moll70a86b02011-06-20 16:03:14 -07001780 ;;
Jim Tanga881a252018-06-19 16:34:41 +08001781 *zsh*)
1782 function check_type() { type "$1"; }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001783 enable_zsh_completion ;;
Raphael Moll70a86b02011-06-20 16:03:14 -07001784 *)
Jim Tanga881a252018-06-19 16:34:41 +08001785 echo -e "WARNING: Only bash and zsh are supported.\nUse of other shell would lead to erroneous results."
Raphael Moll70a86b02011-06-20 16:03:14 -07001786 ;;
1787 esac
Jim Tanga881a252018-06-19 16:34:41 +08001788}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001789
1790# Execute the contents of any vendorsetup.sh files we can find.
Dan Willemsend855a722019-02-12 15:52:36 -08001791# Unless we find an allowed-vendorsetup_sh-files file, in which case we'll only
1792# load those.
1793#
1794# This allows loading only approved vendorsetup.sh files
Jim Tanga881a252018-06-19 16:34:41 +08001795function source_vendorsetup() {
Jim Tangc4dba1d2019-07-25 16:54:27 +08001796 unset VENDOR_PYTHONPATH
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001797 local T="$(gettop)"
Dan Willemsend855a722019-02-12 15:52:36 -08001798 allowed=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001799 for f in $(cd "$T" && find -L device vendor product -maxdepth 4 -name 'allowed-vendorsetup_sh-files' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001800 if [ -n "$allowed" ]; then
1801 echo "More than one 'allowed_vendorsetup_sh-files' file found, not including any vendorsetup.sh files:"
1802 echo " $allowed"
1803 echo " $f"
1804 return
1805 fi
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001806 allowed="$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001807 done
1808
1809 allowed_files=
1810 [ -n "$allowed" ] && allowed_files=$(cat "$allowed")
Jim Tanga881a252018-06-19 16:34:41 +08001811 for dir in device vendor product; do
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001812 for f in $(cd "$T" && test -d $dir && \
Jim Tanga881a252018-06-19 16:34:41 +08001813 find -L $dir -maxdepth 4 -name 'vendorsetup.sh' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001814
1815 if [[ -z "$allowed" || "$allowed_files" =~ $f ]]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001816 echo "including $f"; . "$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001817 else
1818 echo "ignoring $f, not in $allowed"
1819 fi
Jim Tanga881a252018-06-19 16:34:41 +08001820 done
1821 done
1822}
Kenny Root52aa81c2011-07-15 11:07:06 -07001823
Dan Albertbab814f2020-08-26 15:34:53 -07001824function showcommands() {
1825 local T=$(gettop)
1826 if [[ -z "$TARGET_PRODUCT" ]]; then
1827 >&2 echo "TARGET_PRODUCT not set. Run lunch."
1828 return
1829 fi
1830 case $(uname -s) in
1831 Darwin)
1832 PREBUILT_NAME=darwin-x86
1833 ;;
1834 Linux)
1835 PREBUILT_NAME=linux-x86
1836 ;;
1837 *)
1838 >&2 echo Unknown host $(uname -s)
1839 return
1840 ;;
1841 esac
1842 if [[ -z "$OUT_DIR" ]]; then
1843 if [[ -z "$OUT_DIR_COMMON_BASE" ]]; then
1844 OUT_DIR=out
1845 else
1846 OUT_DIR=${OUT_DIR_COMMON_BASE}/${PWD##*/}
1847 fi
1848 fi
1849 if [[ "$1" == "--regenerate" ]]; then
1850 shift 1
1851 NINJA_ARGS="-t commands $@" m
1852 else
1853 (cd $T && prebuilts/build-tools/$PREBUILT_NAME/bin/ninja \
1854 -f $OUT_DIR/combined-${TARGET_PRODUCT}.ninja \
1855 -t commands "$@")
1856 fi
1857}
1858
Jim Tanga881a252018-06-19 16:34:41 +08001859validate_current_shell
1860source_vendorsetup
Kenny Root52aa81c2011-07-15 11:07:06 -07001861addcompletions